-- Just write the code here now. It will execute every time the game loads.

-- Loader --
local frame = CreateFrame("FRAME", "TPOLoader");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
local function eventHandler(self, event, ...)
    index = GetMacroIndexByName("TPO")
    if index > 0 then EditMacro(index, "TPO", "Ability_Garrison_OrangeBird", "/click TPO_Button")
    else CreateMacro("TPO", "Ability_Garrison_OrangeBird", "/click TPO_Button")
    end
end
frame:SetScript("OnEvent", eventHandler);

local frame = CreateFrame("Button", "TPO_Button", nil, "SecureActionButtonTemplate")
frame:SetAttribute("type", "macro")
frame:SetAttribute("macrotext", "/run TPO_resourceCost=nil;if GetMerchantNumItems()==0 then print(\"--------------------------------------------------------------\") end\n/target Trader Yula\n/target Elder Surehide\n/target Pyxni Pennypocket\n/target Tradesman Portanuus\n/target Tai'tasi\n/target Krixel Pinchwhistle\n/target Talgaiir the Ironrender\n/target Ribchewer\n/tpo check\n/stopmacro [noexists]\n/target Trader Joseph\n/target Fayla Fairfeather\n/tpo check\n/cleartarget")

TPO_ahcut = TPO_ahcut or ahcut or 1
TPO_dotdSource = TPO_dotdSource or dotdSource or "DBMarket"
TPO_longTermSource = TPO_longTermSource or longTermSource or "DBHistorical"
local verbose = false
local IDList = {--Item, Ally,Horde},
               {109136,_____,_____}, --Raw Boar Meat
               {109118,87217,87121}, --Blackrock Ore
               {109124,87209,_____}, --Frostweed
               {109125,87208,87119}, --Fireweed
               {109126,87216,_____}, --Gorgrond Flytrap
               {109127,87214,87114}, --Starflower
               {109128,87215,87116}, --Nagrand Arrowbloom
               {109129,87212,87112}, --Talador Orchid
               {109131,_____,_____}, --Raw Clefthoof Meat
               {109132,_____,_____}, --Raw Talbuk Meat
               {109133,_____,_____}, --Rylak Egg
               {109134,_____,_____}, --Raw Elekk Meat
               {109135,_____,_____}, --Raw Riverbeast Meat
               {109119,87211,86803}, --True Iron Ore
               {109137,91071,_____}, --Crescent Saberfish Flesh
               {109138,_____,_____}, --Jawless Skulker Flesh
               {109139,_____,_____}, --Fat Sleeper Flesh
               {109140,_____,_____}, --Blind Lake Sturgeon Flesh
               {109141,_____,_____}, --Fire Ammonite Tentacle
               {109142,_____,_____}, --Sea Scorpion Segment
               {109143,_____,_____}, --Abyssal Gulper Eel Flesh
               {109144,_____,_____}, --Blackwater Whiptail Flesh
               {109693,87207,87120}, --Draenic Dust
               {110609,87210,87115}, --Raw Beast Hide
               {111557,87213,87113}} --Sumptuous Fur 
local bestTraders = {{"Krixel Pinchwhistle", "(N)"},
                     {"Trader Yula", "Elder Surehide"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Krixel Pinchwhistle", "(N)"},
                     {"Krixel Pinchwhistle", "(N)"},
                     {"Krixel Pinchwhistle", "(N)"},
                     {"Krixel Pinchwhistle", "(N)"},
                     {"Krixel Pinchwhistle", "(N)"},
                     {"Trader Yula", "Elder Surehide"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Pyxni Pennypocket", "(N)"},
                     {"Talgaiir the Ironrender", "Ribchewer"},
                     {"Trader Yula", "Elder Surehide"}}

local function inTable(tbl, val)
    for i, v in ipairs(tbl) do
        if v[1] == val or v[2] == val then
            return true
        end
    end
end

local function comparePerTrader(a,b)
    return a[2] > b[2]
end
local function compareAllTraders(a,b)
    return a[4] > b[4]
end

-- SLASH Command --
SLASH_TRADINGPOSTOPTIMISER1, SLASH_TRADINGPOSTOPTIMISER2 = '/tpo', '/tradingpostoptimiser'
function SlashCmdList.TRADINGPOSTOPTIMISER(msg, editbox)
    local cmd, arg = msg:match("^(%S*)%s*(.-)$")
    -- Toggle verbose --
    if msg == "verbose" then
        verbose = not verbose
        print("TPO: verbose now", verbose)
    elseif msg == "ahcut" then
        if TPO_ahcut == 1 then TPO_ahcut = .95 else TPO_ahcut = 1 end
        print("TPO: Using the Auction House cut now", TPO_ahcut==.95)
    -- Set the DotD price source --
    elseif cmd == "dotd" then
        if TSMAPI:ValidateCustomPrice(arg) then
            TPO_dotdSource = arg
            print("TPO: The Deal of the Day price source is now \""..TPO_dotdSource.."\".")
        elseif arg == "" then print("TPO: The Deal of the Day price source is currently \""..TPO_dotdSource.."\".")
        else print("TPO Error: \""..arg.."\" is not a valid price source.")
        end
    -- Set the Long Term price source --
    elseif cmd == "longterm" then
        if TSMAPI:ValidateCustomPrice(arg) then
            TPO_longTermSource = arg
            print("TPO: The best Long Term trade price source is now \""..TPO_longTermSource.."\".")
        elseif arg == "" then print("TPO: The best Long Term trade price source is currently \""..TPO_longTermSource.."\".")
        else print("TPO Error: \""..arg.."\" is not a valid price source.")
        end
    -- Reset configuration --
    elseif msg == "reset" then
        TPO_ahcut = 1
        TPO_dotdSource = "DBMarket"
        TPO_longTermSource = "DBHistorical"
        verbose = false
        print("TPO: Configuration settings reset to defaults.")
    -- Run Trading Post Optimiser --
    elseif msg == "check" then
        -- Initialise the mats --
        local matsList = {}
        for i=1,25 do
            local _, link = GetItemInfo(IDList[i][1])
            table.insert(matsList, {link, 0, bestTraders[i], 0})
        end
        
        -- First pass: Identify daily trader --
        local name = UnitName("target")
        if name == "Trader Yula" or name == "Elder Surehide" then
            if GetMerchantNumItems()==0 then
                print("TPO: Trader Yula (A) / Elder Surehide (H) detected.")
                print("--------------------------------------------------------------")
            end
            TPO_resourceCost = {5,4,8,8,8,8,8,8,5,5,5,5,5,4,8,8,8,8,8,8,8,8,5,10,4}
        elseif name == "Pyxni Pennypocket" then
            if GetMerchantNumItems()==0 then
                print("TPO: Pyxni Pennypocket (N) detected.")
                print("--------------------------------------------------------------")
            end
            TPO_resourceCost = {10,8,4,4,4,4,4,4,10,10,10,10,10,8,10,10,10,10,10,10,10,10,4,8,8}
        elseif name == "Tradesman Portanuus" or name == "Tai'tasi" then
            if GetMerchantNumItems()==0 then
                print("TPO: Tradesman Portanuus (A) / Tai'tasi (H) detected.")
                print("--------------------------------------------------------------")
            end
            TPO_resourceCost = {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6}
        elseif name == "Krixel Pinchwhistle" then
            if GetMerchantNumItems()==0 then
                print("TPO: Krixel Pinchwhistle (N) detected.")
                print("--------------------------------------------------------------")
            end
            TPO_resourceCost = {4,6,10,10,10,10,10,10,4,4,4,4,4,6,5,5,5,5,5,5,5,5,8,8,10}
        elseif name == "Talgaiir the Ironrender" or name == "Ribchewer" then
            if GetMerchantNumItems()==0 then
                print("TPO: Talgaiir the Ironrender (A) / Ribchewer (H) detected.")
                print("--------------------------------------------------------------")
            end
            TPO_resourceCost = {8,10,5,5,5,5,5,5,8,8,8,8,8,10,4,4,4,4,4,4,4,4,10,4,5}
        end
        
        if TPO_resourceCost ~= nil and name ~= "Trader Joseph" and name ~= "Fayla Fairfeather" then
            if not TSMAPI:ValidateCustomPrice(TPO_longTermSource) then print("TPO Error: Deal of the Day custom price \""..TPO_dotdSource.."\"is invalid.")
                if not TSMAPI:ValidateCustomPrice(TPO_longTermSource) then print("TPO Error: Long term custom price \""..TPO_longTermSource.."\"is invalid.") end
            elseif not TSMAPI:ValidateCustomPrice(TPO_longTermSource) then print("TPO Error: Long term custom price \""..TPO_longTermSource.."\"is invalid.")
            else -- Error if custom price is invalid
                for i=1,25 do
                    if TSMAPI:GetCustomPriceValue(TPO_dotdSource,TSMAPI.Item:ToItemString(IDList[i][1])) == nil then matsList[i][2] = 0
                    else matsList[i][2] = (TSMAPI:GetCustomPriceValue(TPO_dotdSource,TSMAPI.Item:ToItemString(IDList[i][1]))*TPO_ahcut)/TPO_resourceCost[i]
                    end
                    if TSMAPI:GetCustomPriceValue(TPO_longTermSource,TSMAPI.Item:ToItemString(IDList[i][1])) == nil then matsList[i][4] = 0
                    else matsList[i][4] = (TSMAPI:GetCustomPriceValue(TPO_longTermSource,TSMAPI.Item:ToItemString(IDList[i][1]))*TPO_ahcut)/4
                    end
                end
                if matsList[2][2] == 0 then print("TPO Warning: Deal of the Day custom price \""..TPO_dotdSource.."\" is valid but returns nil or 0. Assuming 0.") end
                if matsList[2][2] == 0 then print("TPO Warning: Long term custom price \""..TPO_longTermSource.."\" is valid but returns nil or 0. Assuming 0.") end
                local _, link = GetItemInfo(120146)
                table.insert(matsList, {link, 3000, "all Traders", 3000})
                
                -- Get DotD --
                table.sort(matsList, comparePerTrader)
                if verbose then
                    for i=1,25 do
                        print(i,matsList[i][1],TSMAPI:MoneyToString(matsList[i][2],"OPT_PAD","OPT_TRIM"))
                    end
                end
                if GetMerchantNumItems()==0 then print("The deal of the day is "..matsList[1][1].." at "..TSMAPI:MoneyToString(matsList[1][2],"OPT_PAD","OPT_TRIM").." / Resource.") end
                -- Autobuy DotD --
                local _, amount = GetCurrencyInfo(824)
                local cost = 6 -- Maybe eventually replace cost by actual cost of the item
                local buy = floor((amount-5000)/cost)
                if buy > 200 then buy = 200 end
                if buy > 0 and inTable(bestTraders,UnitName("target")) then
                    for i = 1,28 do
                        if GetItemInfo(matsList[1][1]) == GetMerchantItemInfo(i) then BuyMerchantItem(i, buy) end
                    end
                end
                
                -- Get LongTerm --
                table.sort(matsList, compareAllTraders)
                if verbose then
                    for i=1,25 do
                        print(i,matsList[i][1],TSMAPI:MoneyToString(matsList[i][4],"OPT_PAD","OPT_TRIM"))
                    end
                end
                local from = "any Trader"
                if GetItemInfo(matsList[1][1]) == "Smuggled Sack of Gold" then from = "any Trader"
                else from = "from \""..matsList[1][3][1].." / "..matsList[1][3][2].."\"" end
                if GetMerchantNumItems()==0 then print("The best long term profit trade is "..matsList[1][1].." at "..TSMAPI:MoneyToString(matsList[1][4],"OPT_PAD","OPT_TRIM").." / Resource "..from..".") end
                -- Autobuy LongTerm --
                local _, amount = GetCurrencyInfo(824)
                local buy = floor((amount-3000)/4)
                if buy > 200 then buy = 200 end
                if buy > 0 and (UnitName("target") == matsList[1][3][1] or UnitName("target") == matsList[1][3][2]) then
                    for i=1,28 do
                        if GetItemInfo(matsList[1][1]) == GetMerchantItemInfo(i) then BuyMerchantItem(i, buy) end
                    end
                end
            end
        elseif TPO_resourceCost == nil then
            -- Error if no traders --
            print("TPO Error: No traders detected. Please make sure you are in a Garrison with a Trading Post and a trader in target range. If you are, please report your faction and the current trader to the add-on developer at http://wow.curseforge.com/addons/trading-post-optimiser/tickets/")
        end
        
        -- Second pass: Identify daily Work Orders ID--
        if (name == "Trader Joseph" or name == "Fayla Fairfeather") and TPO_resourceCost ~= nil then
            local _,_,_,_,_,npcID = strsplit("-",UnitGUID("target"))
            npcID = tonumber(npcID)
            local flip = "|cFFFFFF00Unknown|r"
            local workOrder = "<WIP npcID:"..tostring(npcID)..">"
            for i=1,25 do
                if (npcID == IDList[i][2] or npcID == IDList[i][3]) then
                    workOrder = TSMAPI.Item:ToItemLink(TSMAPI.Item:ToItemString(IDList[i][1]))
                    if TPO_resourceCost[i] <= 5 then flip = "|cFF00FF00Yes|r" else flip = "|cFFFF0000No|r" end
                end
            end    
            if GetMerchantNumItems()==0 then print("Work Orders:", workOrder, "Worth flipping from Trader:", flip) end
        end
        
    else
        print("--------------------------------------------------------------")
        print("Trading Post Optimiser commands:")
        print("/tpo - Shows the available commands.")
        print("/tpo dotd <priceSource> - Use a custom price source for the Deal of the Day (Current: \""..TPO_dotdSource.."\").")
        print("/tpo longterm <priceSource> - Use a custom price source for the best Long Term trade (Current: \""..TPO_longTermSource.."\").")
        print("/tpo TPO_ahcut - Toggle taking the Auction House cut (5%) into account (Current: "..tostring(TPO_ahcut==.95)..").")
        print("/tpo reset - Reset configuration settings back to defaults.")
        print("/click TPO_Button - Run Trading Post Optimiser (optionally just use the generated \"TPO\" macro).")
        print("/tpo verbose - Toggle verbose mode (Current: "..tostring(verbose)..").")
        print("--------------------------------------------------------------")
    end
end